## borghash 0.1.0

=== debian/changelog ===
borghash (0.1.0-3) unstable; urgency=medium

  * Drop R^3: no, default now
  * Bump std-version to 4.7.2
  * Use pyproject to build

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Nov 2025 08:41:01 +0100

borghash (0.1.0-2) unstable; urgency=medium

  * Add autopkgtest

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 30 May 2025 10:46:22 +0200

borghash (0.1.0-1) unstable; urgency=medium

  * New upstream version 0.1.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 23 Nov 2024 08:55:58 +0100

borghash (0.0.2-1) unstable; urgency=medium

  * New upstream version 0.0.2
    - should fix borgbackup FTBFS on 32bit archs

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 10 Nov 2024 09:20:16 +0100

borghash (0.0.1-2) unstable; urgency=medium

  * Source only reupload

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Nov 2024 23:38:22 +0100

borghash (0.0.1-1) unstable; urgency=low

  * Initial release (Closes: #1086998)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 07 Nov 2024 22:14:57 +0000
