=== debian/control ===
Source: borghash
Section: python
Priority: optional
Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper-compat (= 13),
 python3-setuptools,
 dh-python,
 pybuild-plugin-pyproject,
 cython3,
 python3-all-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/borgbackup/borghash
Vcs-Git: https://salsa.debian.org/debian/borghash.git
Vcs-Browser: https://salsa.debian.org/debian/borghash

Package: python3-borghash
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
Recommends: ${python3:Recommends}
Suggests: ${python3:Suggests}
Description: Memory-efficient hash table (implemented in Cython)
 Memory-efficient hashtable implementations as a Python library,
 implemented in Cython.
