## borghash 0.1.1

=== debian/changelog ===
borghash (0.1.1-1) unstable; urgency=medium

  * Fix previous changelog entry
  * New upstream version 0.1.1
  * Update copyright file
  * Bump std-version to 4.7.3
  * Update package description

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 10:50:03 +0100

borghash (0.1.0-4) unstable; urgency=medium

  * Add python3-all to build depends to fix autopkgtest failures with new
    Python3.14 (Closes: #1123061)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Dec 2025 09:56:55 +0100
